"use strict";
/**
 * Copyright 2018 Novage LLC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var p2p_media_loader_core_1 = require("p2p-media-loader-core");
var segment_manager_1 = require("./segment-manager");
var hlsjs_loader_1 = require("./hlsjs-loader");
var hlsjs_loader_class_1 = require("./hlsjs-loader-class");
var Engine = /** @class */ (function (_super) {
    __extends(Engine, _super);
    function Engine(settings) {
        if (settings === void 0) { settings = {}; }
        var _this = _super.call(this) || this;
        _this.loader = new p2p_media_loader_core_1.HybridLoader(settings.loader);
        _this.segmentManager = new segment_manager_1.SegmentManager(_this.loader, settings.segments);
        Object.keys(p2p_media_loader_core_1.Events)
            .map(function (eventKey) { return p2p_media_loader_core_1.Events[eventKey]; })
            .forEach(function (event) { return _this.loader.on(event, function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return _this.emit.apply(_this, [event].concat(args));
        }); });
        return _this;
    }
    Engine.isSupported = function () {
        return p2p_media_loader_core_1.HybridLoader.isSupported();
    };
    Engine.prototype.createLoaderClass = function () {
        return hlsjs_loader_class_1.createHlsJsLoaderClass(hlsjs_loader_1.HlsJsLoader, this);
    };
    Engine.prototype.destroy = function () {
        this.loader.destroy();
        this.segmentManager.destroy();
    };
    Engine.prototype.getSettings = function () {
        return {
            segments: this.segmentManager.getSettings(),
            loader: this.loader.getSettings()
        };
    };
    Engine.prototype.setPlayingSegment = function (url) {
        this.segmentManager.setPlayingSegment(url);
    };
    return Engine;
}(events_1.EventEmitter));
exports.Engine = Engine;
