/**
 * Copyright 2018 Novage LLC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { LoaderInterface } from "p2p-media-loader-core";
export declare class SegmentManager {
    private loader;
    private masterPlaylist;
    private variantPlaylists;
    private segmentRequest;
    private playQueue;
    private readonly settings;
    constructor(loader: LoaderInterface, settings?: any);
    getSettings(): Settings;
    processPlaylist(url: string, content: string): void;
    loadPlaylist(url: string): Promise<string>;
    loadSegment(url: string, onSuccess: (content: ArrayBuffer, downloadSpeed: number) => void, onError: (error: any) => void): void;
    setPlayingSegment(url: string): void;
    abortSegment(url: string): void;
    destroy(): void;
    private updateSegments;
    private onSegmentLoaded;
    private onSegmentError;
    private onSegmentAbort;
    private getSegmentLocation;
    private loadSegments;
    private getSegmentId;
    private getSwarmId;
}
interface Settings {
    /**
     * Number of segments for building up predicted forward segments sequence; used to predownload and share via P2P
     */
    forwardSegmentCount: number;
}
export {};
